	INCLUDE EFR32MG12.inc		; CPU register definitions
	INCLUDE terminal.inc		; terminal function definitions		
	EXPORT	main
		
;-------------------------------------	; non-initialized DATA segment in RAM 
	AREA	RAM, DATA, NOINIT, READWRITE, ALIGN=3
n	SPACE	4			; 32-bit variable 

;-------------------------------------	; CODE segment in flash (ROM) 
	AREA    |.text|, CODE, READONLY
main	PROC				; main user code
	bl	Terminal_setup		; setup TeraTerm communication

	ldr	R0, =prompt1
	bl	WriteString		; get user input for n
	bl	ReadInt			; R0 = n
	ldr	R1, =n
	str	R0, [R1]		; save n in RAM
	
	ldr	R0, =prompt2		; print n before calling function
	bl	WriteString
	ldr	R0, [R1]		; get number from RAM for output
	bl	WriteInt
	bl	NewLine
	
	ldr	R0, [R1]		; pass parameter to function by value
	push	{R0}			;   in stack
	bl	function
	
	ldr	R0, =prompt3		; print n after calling function
	bl	WriteString
	ldr	R0, [R1]		; get number from RAM for output
	bl	WriteInt
	bl	NewLine
	bl	NewLine
	
loop	b	loop			; repeat periodic task		
	ENDP

;-------------------------------------
function PROC				; R0 = parameter
	push	{LR}			; save return address
	ldr	R0, [SP, #4]		; get parameter from stack
	
	add	R0, #5			; modify the parameter
	
	push	{R0}			; preserve R0
	ldr	R0, =prompt4
	bl	WriteString
	pop	{R0}			; rest0re R0
	bl	WriteInt		; print param. value visible by function
	bl	NewLine
	
	ldr	PC, [SP], #8		; return to main
	ENDP
		
;-------------------------------------
prompt1	DCB	"Enter a number: ", 0	
prompt2 DCB	"Before calling function: n = ", 0
prompt3 DCB	"After  calling function: n = ", 0
prompt4 DCB	"   Within function: n = ", 0

	ALIGN
	END